module GunitRails
  module DataManagement
    # This code is to be run in either :development or :test mode
    class SortDependencies
    end

    class Generate
      def build_table(model)
        # Each time this is called, some stuff must have happened:
        #   models/*_stem.rb classes have been instantiated and are accessible
        #   this model's parent tables have been cached
        #
        # This function must do:
        #   fetch macros list for ModelStem
        #   call ModelStem.seed and parent's .reseed methods
        #     use params to decide a valid :belongs_to scenario
        #     generate SEED_MAX records
        #   persist to database
        #   set a reference to the fresh copy in memory
        #
        # After this function:
        #   If there are more tables to generate data for, keep going
        #   else stop
      end
    end

    class Cleanup
    end
  end
end
# decide how much data is needed
# for now, build_table inserts data into AppStem because it's a Hash
# What is the best way to access AppStem?
# Before every test suite is finished setting up,
#   table_list = DependencySorting.sort_tables
#   table_list.each { |table| Generator.build_table(table) }
